## Macros
UNAME_S=$(shell uname -s)
VERSION=2014
LIBVERSION=2014

CC=$(CROSS_COMPILE)gcc
LD=$(CROSS_COMPILE)gcc
CFLAGS=-std=c99 -g -Wall -Werror -O3  -I.
CFLAGS_TEST=$(CFLAGS) -Itest -DVERSION=$(VERSION)
LDFLAGS=-L..
LDLIBS=-llabcomm$(LIBVERSION)

ifeq ($(CROSS_COMPILE),i586-wrs-vxworks-)
  ALL_DEPS:=$(filter-out %.so, $(ALL_DEPS)) # PIC is only supported for RTPs
  CFLAGS:=$(CFLAGS) -DLABCOMM2014_COMPAT=\"labcomm$(VERSION)_compat_vxworks.h\"
else ifeq ($(UNAME_S),Linux)
  LDLIBS+=-lrt
  MAKESHARED=gcc -o $1 -shared -Wl,-soname,$2 $3 -lc -lrt
else ifeq ($(UNAME_S),Darwin)
  CFLAGS+=-DLABCOMM2014_COMPAT=\"labcomm$(VERSION)_compat_osx.h\" \
	  -DLABCOMM_OS_DARWIN=1 \
	  -Wno-unused-function
  MAKESHARED=clang -o $1 -shared -Wl,-install_name,$2 $3 -lc
else ifneq ($(findstring CYGWIN,$(UNAME_S)),)
  LDLIBS+=-lrt
  ALL_DEPS:=$(filter-out %.so, $(ALL_DEPS)) # No -fPIC supported in windows?
else
  $(error Unknown system $(UNAME_S))
endif

